package com.its.op.service.its.scrs;

import com.its.op.dao.repository.its.scrs.TbScIxrGemtMngmRepository;
import com.its.op.dto.its.scrs.TbScIxrGemtMngmDto;
import com.its.op.dto.its.scrs.TbScTrfcCndtMngmDto;
import com.its.op.entity.its.scrs.TbScIxrGemtMngm;
import com.its.op.entity.its.scrs.TbScIxrGemtMngmKey;
import com.its.op.entity.its.scrs.TbScTrfcCndtMngm;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbScIxrGemtMngmService {

    private final TbScIxrGemtMngmRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbScIxrGemtMngm requireOne(TbScIxrGemtMngmKey ixrId) throws NoSuchElementException {
        Optional<TbScIxrGemtMngm> info = this.repo.findById(ixrId);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + ixrId);
        }
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbScIxrGemtMngmDto> findAll() {
        List<TbScIxrGemtMngmDto> result = new ArrayList<>();
        List<TbScIxrGemtMngm> data = this.repo.findAll();
        for (TbScIxrGemtMngm entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbScIxrGemtMngmDto> findAllList() {
        List<TbScIxrGemtMngmDto> result = new ArrayList<>();
        List<TbScIxrGemtMngm> data = this.repo.findAllList();
        for (TbScIxrGemtMngm entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbScIxrGemtMngmDto findById(TbScIxrGemtMngmKey ixrId) {
        TbScIxrGemtMngm entity = requireOne(ixrId);
        return entity.toDto();
    }

    @Transactional(readOnly = true)
    public List<TbScIxrGemtMngmDto> findListById(String ixrId) {
        List<TbScIxrGemtMngm> data = this.repo.findListById(ixrId);
        List<TbScIxrGemtMngmDto> result = new ArrayList<>();
        for (TbScIxrGemtMngm entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 변경
    @Transactional
    public TbScIxrGemtMngmDto updateById(TbScIxrGemtMngmKey ixrId, TbScIxrGemtMngmDto.TbScIxrGemtMngmUpdReq req) {
        TbScIxrGemtMngm entity = requireOne(ixrId);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbScIxrGemtMngmDto> mergeInfoList(List<TbScIxrGemtMngmDto.TbScIxrGemtMngmUpdReq> reqList) {
        List<TbScIxrGemtMngmDto> result = new ArrayList<>();
        for (TbScIxrGemtMngmDto.TbScIxrGemtMngmUpdReq req : reqList) {
            TbScIxrGemtMngm obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbScIxrGemtMngmDto mergeInfo(TbScIxrGemtMngmDto.TbScIxrGemtMngmUpdReq req) {
        TbScIxrGemtMngm obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbScIxrGemtMngmDto deleteById(TbScIxrGemtMngmKey ixrId) {
        TbScIxrGemtMngm entity = requireOne(ixrId);
        this.repo.deleteById(ixrId);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbScIxrGemtMngmDto> deleteByIds(List<TbScIxrGemtMngmKey> ids) {
        List<TbScIxrGemtMngmDto> result = new ArrayList<>();
        for (TbScIxrGemtMngmKey id : ids) {
            Optional<TbScIxrGemtMngm> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

}
